

                    .chip 65c02

     
; new V6502 opcodes macros
phr:                .macro             ;AXY->SP: push A,X,Y to stack (useful for fast context switch) 
                    .byte        $8b
                    .endm
                    
plr:                .macro             ;SP->YXA: pull A,X,Y from stack (useful for fast context switch)
                    .byte        $ab
                    .endm

taz:                .macro             ;A->Z: copy A to zero page register (MSB base address)
                    .byte        $1b
                    .endm
                    
tza:                .macro             ;Z->A: copy zero page register to A
                    .byte        $3b
                    .endm

txy:                .macro             ;X->Y: copy X to Y
                    .byte        $9b
                    .endm
                    
tyx:                .macro             ;Y->X: copy Y to X 
                    .byte        $bb
                    .endm

xyx:                .macro             ;X<->Y: exchange X with Y 
                    .byte        $eb
                    .endm

xax:                .macro             ;A<->X: exchange A with X
                    .byte        $0b
                    .endm

xay:                .macro             ;A<->Y: exchange A with Y
                    .byte        $2b
                    .endm

isp:                .macro             ;X -> S (lsb); A -> S msb: copy X and A to S (16 bit stack pointer)
                    .byte        $4b
                    .endm

tsp:                .macro             ;S lsb -> X; S msb -> A: copy S to X and A 
                    .byte        $5b
                    .endm

                    
jsrx:               .macro       arg1  ;JSR ($XXXX,X) jump vector table indexed by X
                    .byte        $fc
                    .word        arg1
                    .endm
                    
                   
           
start               sei                            ;disable all interrupts
                    cld                            ;clear decimal mode
                    lda    #$10
                    ldx    #$ff                    ;initializes stack pointer at $10ff (default msb of S is initialized at $01, in order to keep compatibility with standard 6502)
                    isp
                    ;txs            

																	   lda    #$2a                    ;init zero page base address at $2A00    
                    taz

                    
;INTERRUPTS:                    
;NMI routine           
nmik                phr                            ;push A,X,Y on stack
																				;place NMI code here
                    plr                            ;pull A,X,Y from stack
                    rti                            ;return from interrupt  

;IRQ routine
irqk                phr                            ;push A,X,Y on stack
																				;place IRQ code here
                    plr                            ;pull A,X,Y from stack
                    rti                            ;return from interrupt  

           
                   .ends
           
                   ;CPU vectors           
                   .org  $fffa
                   .word nmik,start,mcp
                   .end
           